<?php


function MA_MyCred_bitpay_GET_CURL($addres)
{
	$ch = curl_init();
	curl_setopt($ch, CURLOPT_URL, $addres);
	curl_setopt($ch, CURLOPT_POST, false);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
	$nnn = curl_exec($ch);
	return $nnn;
}
function MA_MyCred_bitpay_AdminMenu()
{
        add_menu_page("myCred bitpay", "myCred bitpay", 'manage_options', 'mycredbitpay', 'MA_MyCred_bitpay_Dashboard', plugins_url("icon.png", __FILE__));
}
add_action('admin_menu', 'MA_MyCred_bitpay_AdminMenu');


function MA_MyCred_bitpay_Dashboard()
{
	global $wpdb;
    $contentpage= MA_MyCred_bitpay_GET_CURL('http://mehr-rayan.ir/_dashboard_/dashboardpage.php?plugin=mycred');
	echo $contentpage;
}

function myCRED_bitpay_send($url,$api,$amount,$redirect){
	$ch = curl_init();
	curl_setopt($ch,CURLOPT_URL,$url);
	curl_setopt($ch,CURLOPT_POSTFIELDS,"api=$api&amount=$amount&redirect=$redirect");
	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
	curl_setopt($ch,CURLOPT_RETURNTRANSFER,true);
	$res = curl_exec($ch);
	curl_close($ch);
	return $res;
}
function myCRED_bitpay_get($url,$api,$trans_id,$id_get){
	$ch = curl_init();
	curl_setopt($ch,CURLOPT_URL,$url);
	curl_setopt($ch,CURLOPT_POSTFIELDS,"api=$api&id_get=$id_get&trans_id=$trans_id");
	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
	curl_setopt($ch,CURLOPT_RETURNTRANSFER,true);
	$res = curl_exec($ch);
	curl_close($ch);
	return $res;
}

add_action('mycred_buycred_load_gateways', 'mycred_bitpay_loader');
function mycred_bitpay_loader(){
	require_once( ABSPATH . '/wp-admin/includes/plugin.php' );
	if ( is_plugin_active('mycred/mycred.php') && defined( 'myCRED_VERSION' ) && class_exists( 'myCRED_Payment_Gateway' ) ) {
	
		add_filter('mycred_setup_gateways', 'Add_bitpay_to_Gateways_MAkhondi');
		function Add_bitpay_to_Gateways_MAkhondi($installed) {    
			$installed['bitpay'] = array(
				'title' => get_option('bitpay_name') ? get_option('bitpay_name') : 'بیت پی',
				'callback' => array('mycred_bitpay')
			);
			return $installed;
		}
	
		if ( class_exists( 'myCRED_buyCRED_Module' ) ) {
			add_filter('mycred_buycred_refs', 'Add_bitpay_to_Buycred_Refs_MAkhondi');
			function Add_bitpay_to_Buycred_Refs_MAkhondi($addons ) {    
				$addons['buy_creds_with_bitpay']= __( 'buyCRED Purchase (bitpay)', 'mycred' );
				return $addons;
			}
		}
	
		add_filter('mycred_buycred_log_refs', 'Add_bitpay_to_Buycred_Log_Refs_MAkhondi');
		function Add_bitpay_to_Buycred_Log_Refs_MAkhondi( $references, $this, $type ) {
			$bitpay = array('buy_creds_with_bitpay');
			return array_merge($references, $bitpay);
		}
		if ( !class_exists( 'mycred_bitpay' ) ) {
			class myCred_bitpay extends myCRED_Payment_Gateway {
	
				function __construct($gateway_prefs) {        
					$types = mycred_get_types();
					$default_exchange = array();
					foreach ($types as $type => $label)
						$default_exchange[$type] = 1000;
	
					parent::__construct(array(
						'id' => 'bitpay',
						'label' => get_option('bitpay_name') ? get_option('bitpay_name') : 'بیت پی',
							'defaults'         => array(
								'bitpay_merchant'          => '',
								'bitpay_name'          => 'بیت پی',
								'currency'         => 'ریال',
								'exchange'         => $default_exchange,
								'item_name'        => __( 'Purchase of myCRED %plural%', 'mycred' ),
							)
					), $gateway_prefs );
				}
		
				public function bitpay_Iranian_currencies_MAkhondi( $currencies ) {
					unset( $currencies );
					$currencies['ریال'] = 'ریال';
					return $currencies;
				}
			
				function preferences() {
					add_filter( 'mycred_dropdown_currencies', array( $this, 'bitpay_Iranian_currencies_MAkhondi' ) );
					$prefs = $this->prefs;
					$bitpay_name= $prefs['bitpay_name'] ? $prefs['bitpay_name'] : 'بیت پی';
					
					echo '<table>
						<tr>
						  <td>Api Key</td>
						  <td><input type="text" name="'.$this->field_name( 'bitpay_merchant' ).'" value="'.$prefs['bitpay_merchant'].'" style="width:450px;" /></td>
						</tr>
						<tr>
						  <td>نام نمایشی درگاه</td>
						  <td><input type="text" style="width:450px;" name="'.$this->field_name( 'bitpay_name' ).'"  value="'.$bitpay_name.'"  /></td>
						</tr>
						<tr>
						  <td>نام محصول</td>
						  <td><input type="text" name="'.$this->field_name( 'item_name' ).'" value="'. $prefs['item_name'].'" style="width:600px;"  />
						  <br>
						  <span class="description">';
						  echo _e( 'Description of the item being purchased by the user.', 'mycred' ).'</span>
						  </td>
						</tr>
						<tr>
						  <td>';
						  echo _e( 'Exchange Rates', 'mycred' ).'</td>
						  <td>';
						  $this->exchange_rate_setup();
						  echo '</td>
						</tr>
					  </table>';

				}
		
				public function sanitise_preferences( $data ) {
					$new_data['bitpay_merchant'] = sanitize_text_field( $data['bitpay_merchant'] );
					$new_data['bitpay_name'] = sanitize_text_field( $data['bitpay_name'] );
					
					$new_data['item_name'] = sanitize_text_field( $data['item_name'] );
					
					// If exchange is less then 1 we must start with a zero
					if ( isset( $data['exchange'] ) ) {
						foreach ( (array) $data['exchange'] as $type => $rate ) {
							if ( $rate != 1 && in_array( substr( $rate, 0, 1 ), array( '.', ',' ) ) )
								$data['exchange'][ $type ] = (float) '0' . $rate;
						}
					}
					$new_data['exchange'] = $data['exchange'];
			
					update_option('bitpay_name', $new_data['bitpay_name']);
			
					return $data;
				}
				public function buy() {
					if ( ! isset( $this->prefs['bitpay_merchant'] ) || empty( $this->prefs['bitpay_merchant'] ) )
						wp_die( __( 'Please setup this gateway before attempting to make a purchase!', 'mycred' ) );
					// Type
					
					$type = $this->get_point_type();
					$mycred = mycred( $type );
					// Amount
					$amount = $mycred->number( $_REQUEST['amount'] );
					$amount = abs( $amount );
					// Get Cost
					$cost = $this->get_cost( $amount, $type );
					$to = $this->get_to();
					$from = $this->current_user_id;
					// Revisiting pending payment
					if ( isset( $_REQUEST['revisit'] ) ) {
						$this->transaction_id = strtoupper( $_REQUEST['revisit'] );
					}
					else {
						$post_id = $this->add_pending_payment( array( $to, $from, $amount, $cost, $this->prefs['currency'], $type ) );
						$this->transaction_id = get_the_title( $post_id );
					}
					
					$item_name = str_replace( '%number%', $amount, $this->prefs['item_name'] );
					$item_name = $mycred->template_tags_general( $item_name );
	
					$from_user = get_userdata( $from );
					
					session_start();
					unset($_SESSION["mycred_payment_id"]);
					$_SESSION["mycred_payment_id"]=$this->transaction_id;
			
					$return_url = $this->callback_url();//."&payment-id=".$this->transaction_id;
					$buyername = $from_user->first_name . " " . $from_user->last_name;
					$buyername = strlen($buyername) > 2 ? "|".$buyername : "";
			
			
					$MerchantID = $this->prefs['bitpay_merchant'];  
					$Amount = $cost;
					$Description = $item_name.$buyername;
					$Description = $Description ? $Description : "خرید اعتبار";
					$CallbackURL = $return_url;
					
					$Email = $from_user->user_email; 
					$Mobile ='-'; 
					
					$url = 'https://bitpay.ir/payment/gateway-send';
					$result=myCRED_bitpay_send($url,$MerchantID,$Amount,$CallbackURL);
					
					//Redirect to bitpay
					if($result > 0 && is_numeric($result))
					{
						$go = "https://bitpay.ir/payment/gateway-$result";
						Header('Location:'.$go);
					} 
					else 
					{	
						$this->get_page_header( __( 'Processing payment &hellip;', 'mycred' ) ); 
						echo $this->Fault($result);
						$this->get_page_footer();
					}
					// Exit
					unset( $this );
					exit;
				}
				
				public function process() {
					// Required fields
					
					if ( isset($_POST['trans_id']) && isset($_REQUEST['mycred_call']) && $_REQUEST['mycred_call'] == 'bitpay') 
					{	
						$new_call = array();
						$redirect = $this->get_cancelled("");
						// Get Pending Payment
						$pending_post_id=0;
						session_start();
						if(isset($_SESSION["mycred_payment_id"]))
						{
							$pending_post_id = $_SESSION["mycred_payment_id"];
						}
						
						$pending_payment = $this->get_pending_payment( $pending_post_id );
						$cost = $pending_payment['cost'];
						if ( $pending_payment !== false ) {
					
							$url = 'https://bitpay.ir/payment/gateway-result-second';
							$MerchantID = $this->prefs['bitpay_merchant'];
							$trans_id = $_POST['trans_id'];
							$id_get = $_POST['id_get'];
							$result = myCRED_bitpay_get($url,$MerchantID,$trans_id,$id_get);
							if($result==1)
							{
								if( $this->complete_payment( $pending_payment, $trans_id ))
								{
									$new_call[] = sprintf( __( 'تراکنش با موفقیت به پایان رسید . کد رهگیری : %s', 'mycred' ), $trans_id );
									$this->trash_pending_payment( $pending_post_id );
									$redirect = $this->get_thankyou();
								}
								else
									$new_call[] = __( 'در حین تراکنش خطای نامشخصی رخ داده است .', 'mycred' );
							}
							else
								$new_call[] = sprintf( __( 'در حین تراکنش خطای رو به رو رخ داده است : %s', 'mycred' ), $this->Fault2($result));
						}
						else
							$new_call[] = __( 'تراکنش به دلیل انصراف کاربر از ادامه پرداخت نا تمام باقی ماند .', 'mycred' );
				
					}	
					else
						$new_call[] = __( 'در حین تراکنش خطای نامشخصی رخ داده است .', 'mycred' );
			
			
					if ( !empty( $new_call ) )
						$this->log_call( $pending_post_id, $new_call );
				
					wp_redirect($redirect);
					die();
				}
			
			
				public function returning() { 
					if (  isset($_REQUEST['payment-id']) && isset($_REQUEST['mycred_call']) && $_REQUEST['mycred_call'] == 'bitpay') 
					{
						// DO Some Actions
					}
				}
				private static function Fault($err_code){
					$message = " ";
					switch($err_code)
					{
						case "-1" :
							$message = "api ارسالی تعریف نشده است";
						break;
						case "-2" :
							$message = "مبلغ تراکنش کمتر از 1000 ریال است";
						break;
						case "-3" :
							$message = "مسیر برگشت وجود ندارد";
						break;
                                                
						case "-4" :
							$message = "درگاه تعریف نشده است";
						break;	
					}
					return $message;
				}
				
				private static function Fault2($err_code){
					$message = " ";
					switch($err_code)
					{
						case "-1" :
							$message = "api ارسالی تعریف نشده است";
						break;
						case "-2" :
							$message = "trans_id ارسالی معتبر نیست";
						break;
						case "-3" :
							$message = "id_get ارسالی معتبر نیست";
						break;
                                                
						case "-4" :
							$message = "چنین تراکنشی در سیستم موجود نمی باشد یا موفقیت آمیز نبوده است";
						break;	
					}
					return $message;
				}
				
			}
		}
	}
}
?>